// Filename: main.js

// Require.js allows us to configure shortcut alias
// This is the entry point into the code, where we configure require.js and start the app.
//Require.js looks for a config file to setup the dependency configuration for the app.
//This is where we are going to call the script files we were originally calling from index.html.
//The require() function is used to run immediate functionalities, while define() is used to define modules for use in multiple locations. 
 console.log("main.js");
require(['state/Boot','state/Load','state/Start','state/MainIntro','state/MainMenu','state/LevelControl','state/GamePlay','state/GameEnd',"phaser.min"],function(Boot,Load,Start,MainIntro,MainMenu,LevelControl,GamePlay,GameEnd){

    var _game = new Phaser.Game(800, 600, Phaser.AUTO, 'game');

    //Boot state
	//The Boot state loads preloader assets in the preload hook method and sets up Phaser game settings like 		scaling and input pointers via the create method-- Configuration .
   
	Boot.init(_game,'Load'); //args: game object(state name), next state
	_game.state.add('Boot',Boot.getBootState()); //args: state name, geting the boot state
	
    //Load state
    Load.init(_game,'Start'); //args: game object, next state
    _game.state.add('Load',Load.getLoadState()); //args: state name, geting the load state
    
   	//Start State
    Start.init(_game,'MainIntro');
    _game.state.add('Start',Start.getStartState());
	
	//MainIntro State
    MainIntro.init(_game,'MainMenu');
    _game.state.add('MainIntro',MainIntro.getMainIntroState());
    
    //MainMenu State
    MainMenu.init(_game,'LevelControl');
    _game.state.add('MainMenu',MainMenu.getMainMenuState());
    
    //LevelControl State
    LevelControl.init(_game,'GamePlay',{level: 1,score: 0});
    _game.state.add('LevelControl',LevelControl.getLevelControlState());
	
	//GamePlay State
    GamePlay.init(_game,'GameEnd');
    _game.state.add('GamePlay',GamePlay.getGamePlayState());
    
    //GameEnd State
    GameEnd.init(_game,'GameEnd');
    _game.state.add('GameEnd',GameEnd.getGameEndState());
	
	//Starting the Boot state
    _game.state.start('Boot');
    
});
