'use strict';

define(['modules/Config','modules/Background','modules/Hud','modules/Intro','modules/Menu','modules/Level','modules/Player','modules/Doors','modules/Guards'], function(Config,Background,HUD,Intro,Menu,Level,Player,Doors,Guards) {
    var _game = null,
        _nextStage = null;
    
    //Loading State
    var _Load = {  
      
		preload: function() {
            // load all game assets
            // images, spritesheets, atlases, audio etc..
			
			
			
			//Background
            Background.init(_game);
            Background.preload();

            //HUD
            HUD.init(_game);
			HUD.preload();		
			//Intro  Splash Screen        
            Intro.init(_game);
            Intro.preload();
			
			//Menu   Instructions/credit/Play           
            Menu.init(_game);
            Menu.preload();
			
			Level.init(_game);
            Level.preload();
			
			//Player    Game PLay        
            Player.init(_game);
            Player.preload();
			
			//Doors            
            Doors.init(_game);
            Doors.preload();
			
			//guards            
            Guards.init(_game);
            Guards.preload();
			// to do: other game entities initiate/preload
        },

        create: function() {
			console.log("Load:create");
			//Starting the next state(mainIntro) after the spacebar is down
			//Config.create();
			//Background.create();
			
                      
            _game.state.start('Start');
        }
    }

    return {
	init: function(game,nextStage){
            _game = game;
            _nextStage = nextStage;
        },
        getLoadState: function(){
            return(_Load);
        }
        
    }
})
